<template>
  <div class="card">
    <Menubar :model="menuItems" />
    <Toast />
    <!-- TODO: lo he comentado porque aún no tiene uso, sin embargo, para darle función de cargar
      archivos se debe revisar y activar
    <OverlayPanel ref="uploadPanel">
      <div class="flex flex-column gap-3 w-25rem">
        <FileUpload mode="advanced" name="demo[]" url="/api/upload" @select="onSelect"
          @upload="onAdvancedUpload($event)" disable="true" :multiple="false" accept="" :maxFileSize="1000000"
          :showUploadButton="false" :showCancelButton="false" :fileLimit="1" :auto="true">
          <template #empty>
            <p>{{ titleDrag }}</p>
          </template>
</FileUpload>
</div>
</OverlayPanel>
-->
    <Dialog v-model:visible="visibleSelectDirPath" modal :header="titleDirPathDialog" :style="{ width: '25rem' }">
      <div>
        <InputText type="text" v-model="inputPath" />
      </div>
      <div>
        <Button type="button" :label="labelButtonClose" severity="secondary"
          @click="visibleSelectDirPath = false"></Button>
        <Button type="button" :label="labelButtonOk" @click="selectDirPath"></Button>
      </div>
    </Dialog>
    <Dialog v-model:visible="visibleNewProject" modal :header="titleNewProjectDialog" :style="{ width: '35rem' }">
      <div>
        <p>{{ labelInputNewProject }}</p>
        <InputText type="text" v-model="inputNewProject" />
        <p>{{ labelDirPathDialog }}</p>
        <p>{{ labelSelectPlatform }}</p>
      </div>
      <div v-for="plugin in props.plugins" class="flex align-items-center">
        <RadioButton v-model="selectedPlugin" :inputId="plugin.platform" name="dynamic" :value="plugin.platform" />
        <label :for="plugin.platform" class="ml-2">{{ plugin.platform }}</label>
      </div>
      <div>
        <p>{{ labelSelectProjectType }}</p>
      </div>
      <div v-for="projectType in projectTypesFromDialog" class="flex align-items-center">
        <RadioButton v-model="selectedProjectType" :inputId="projectType" name="dynamic" :value="projectType" />
        <label :for="projectType" class="ml-2">{{ projectType }}</label>
      </div>
      <div>
        <Button type="button" :label="labelButtonClose" severity="secondary"
          @click="visibleNewProject = false"></Button>
        <Button type="button" :label="labelButtonOk" @click="setNewProject"></Button>
      </div>
    </Dialog>
  </div>
</template>

<script setup lang="ts">
import { ref, onMounted, watch } from "vue";
// Components
import Toast from 'primevue/toast';
import Menubar from 'primevue/menubar';
import OverlayPanel from 'primevue/overlaypanel';
import FileUpload from 'primevue/fileupload';
import Dialog from 'primevue/dialog';
import InputText from 'primevue/inputtext';
import Button from 'primevue/button';
import RadioButton from 'primevue/radiobutton';
// Adds js/ts
import { useToast } from "primevue/usetoast";
import { dirconfig } from "../core/menubarcommon";
import { EXTENSIONS, EXT_NAME, LANG, TYPE_DIALOG_REQUEST } from '@/core/consts';
import { menubarcommonLang, getTextFromLang } from "@/core/lang";
import type { PluginDictionary, DialogRequest, DataDialog } from '@/core/types';

const toast = useToast();
const titleDrag = ref("Soltar aquí el directorio de trabajo")

// props
// const props = defineProps({
//   lang: {
//     type: Number,
//     require: true,
//     default: LANG.EN
//   },
//   workDirPath: {
//     type: String,
//     require: true,
//     default: "",
//   }
// });

const props = defineProps<{
  lang: LANG,
  workDirPath: string,
  filePathSelected: string,
  plugins: PluginDictionary,
}>();

//-- SELECT DIR PATH DIALOG --
/** Visibilidad para el dialogo selector de el dir path de workspace */
const visibleSelectDirPath = ref(false);
const titleDirPathDialog = ref("");
/** Entrada para insertar path */
const inputPath = ref("");

//-- NEW PROJECT DIALOG --
/** Visibilidad para el dialogo selector nuevo proyecto */
const visibleNewProject = ref(false);
const titleNewProjectDialog = ref("");
const labelInputNewProject = ref("");
/** Entrada para nuevo proyecto */
const inputNewProject = ref("");
const labelDirPathDialog = ref("");
const labelSelectPlatform = ref("");
const labelSelectProjectType = ref("");

//-- COMMUN DIALOG --
const labelButtonOk = ref("");
const labelButtonClose = ref("");

const selectedPlugin = ref<string>('');

//emits
const emit = defineEmits(['dirconfig-update', 'save-project-request', 'dir-path-selected', 'new-project-request', 'run-app-function-with-dialog-request']);

// ref()
const menuItems = ref<any>([]);
// const uploadPanel = ref();

// const toggleUploadPanel = (event: any) => {
//   uploadPanel.value.toggle(event);
// }

// const onSelect = (file: any) => {
//   console.log(file)
// }

const setMenuItems = (lang: LANG) => {
  menuItems.value = [
    {
      label: getTextFromLang(menubarcommonLang.file, lang),
      icon: 'pi pi-file',
      items: [
        {
          label: getTextFromLang(menubarcommonLang.newProject, lang),
          icon: 'pi pi-file-plus',
          command: () => {
            // Limpiar anteriores entradas
            inputNewProject.value = "";
            // Actualizar información del diálogo
            updateNewProjectDialog(props.lang);
            // Presentar la ventana de diálogo
            visibleNewProject.value = true;
          }
        },
        {
          label: getTextFromLang(menubarcommonLang.opendir, lang),
          icon: 'pi pi-folder-open',
          command: () => {
            inputPath.value = "";
            visibleSelectDirPath.value = true;
            // TODO: debido a temas de seguirdad, esta función no puede operar
            // parar obtener el path absoluto, se requiere otra opción
            // toggleUploadPanel(event);
          }
        },
        {
          label: getTextFromLang(menubarcommonLang.save, lang),
          icon: 'pi pi-save',
          command: () => {
            emit('save-project-request');
            // toast.add({ severity: 'warn', summary: 'Search Results', detail: 'No results found', life: 3000 });
          }
        },
        {
          label: getTextFromLang(menubarcommonLang.delete, lang),
          icon: 'pi pi-eraser',
          command: () => {
            const dialogRequest: DialogRequest = {
              typeDialog: TYPE_DIALOG_REQUEST.YES_OR_NO_QUESTION,
              data: {
                title: getTextFromLang(menubarcommonLang.dialogDeleteFile.title, lang),
                content: getTextFromLang(menubarcommonLang.dialogDeleteFile.content, lang) + props.filePathSelected,
                emit: "delete-file-request",
                args: { filePath: props.filePathSelected },
                okLabel: getTextFromLang(menubarcommonLang.dialogButtonYesNo.ok, lang),
                cancelLabel: getTextFromLang(menubarcommonLang.dialogButtonYesNo.close, lang),
              }
            };
            emit('run-app-function-with-dialog-request', dialogRequest);
          }
        },
        {
          label: getTextFromLang(menubarcommonLang.fileUpload, lang),
          icon: 'pi pi-file-arrow-up',
          command: () => {
            const data: DataDialog = {
              title: "Subir archivos",
              content: "nn",
              emit: "upload-file",
              args: {},
            }
            const dialogRequest: DialogRequest = {
              typeDialog: TYPE_DIALOG_REQUEST.UPLOADFILE,
              data: data,
            }
            emit('run-app-function-with-dialog-request', dialogRequest);
          }
        }
      ]
    },
  ]
}

const selectDirPath = () => {
  visibleSelectDirPath.value = false;
  emit('dir-path-selected', inputPath.value);
}

/** */
watch(inputNewProject, (projectName: string) => {
  // Obtener extensión
  const ext = (projectName.split('.').pop()) ? projectName.split('.').pop() : "";
})

const updateSelectDirPathDialog = (lang: LANG) => {
  titleDirPathDialog.value = getTextFromLang(menubarcommonLang.selectDirPath.header, lang);
}

const updateNewProjectDialog = (lang: LANG) => {
  // Título del dialogo
  titleNewProjectDialog.value = getTextFromLang(menubarcommonLang.dialogNewProject.header, lang);
  // Etiqueta para ingresar el nombre del archivo con sugerencia de extensión
  labelInputNewProject.value = getTextFromLang(menubarcommonLang.dialogNewProject.labelInput, lang) +
    " (." + EXTENSIONS.replace(/ /g, ", .") + "):";
  // Etiqueta que indica en qué directorio se creará el archivo
  labelDirPathDialog.value = getTextFromLang(menubarcommonLang.dialogNewProject.labelDirPath, lang) +
    "\"" + props.workDirPath + "\".";
  // Etiqueta para el selector de platform
  labelSelectPlatform.value = getTextFromLang(menubarcommonLang.dialogNewProject.labelSelectPlatform, lang);
  // Etiqueta para el selector del tipo de proyecto
  labelSelectProjectType.value = getTextFromLang(menubarcommonLang.dialogNewProject.labelSelectProjectType, lang);
}

const updateCommunDialog = (lang: LANG) => {
  labelButtonOk.value = getTextFromLang(menubarcommonLang.dialogButton.ok, lang);
  labelButtonClose.value = getTextFromLang(menubarcommonLang.dialogButton.close, lang);
}

const updateLabels = (lang: LANG) => {
  // SelectDirPathDialog
  updateSelectDirPathDialog(lang);
  // NewProjectDialog
  updateNewProjectDialog(lang);
  // Commun Dialog
  updateCommunDialog(lang);
}

/** Se obtiene el path del archivo junto al contenido */
const setNewProject = () => {
  let content = "";
  let extension = "";
  // selectedPlugin, selectedProjectType
  if (selectedProjectType.value == "Blockly") {
    content = props.plugins[selectedPlugin.value].blockly_template;
    extension = ".json"
  } else {
    content = props.plugins[selectedPlugin.value].lang_template;
    extension = "." + props.plugins[selectedPlugin.value].platformLang.extension;
  }
  const path = props.workDirPath + "/" + inputNewProject.value + extension;
  emit('new-project-request', path, content);
  visibleNewProject.value = false;
}

//--  START WATCHERS --
// Actualizar al cambio del idioma
watch(() => props.lang, (lang) => {
  updateLabels(lang);
  setMenuItems(lang)
});

/** Se puede seleccionar si el proyecto a crear es de tipo texto o de blockly */
const projectTypesFromDialog = ref<string[]>([]);

/** Tipo de proyecto seleccionado */
const selectedProjectType = ref<string>("");

watch(selectedPlugin, () => {
  // Limpiar las opciones de los posibles proyectos
  projectTypesFromDialog.value = [];
  // Poner el nombre del lenguaje de texto en función de la extensión
  const lang_extension: string = props.plugins[selectedPlugin.value].platformLang.extension;
  const labelLang = EXT_NAME[lang_extension];
  projectTypesFromDialog.value.push(labelLang);
  if (props.plugins[selectedPlugin.value].blockly_template != undefined) {
    projectTypesFromDialog.value.push("Blockly");
  }
})

//-- END WATCHERS --

onMounted(() => {
  updateLabels(props.lang);
  setMenuItems(props.lang)
})

</script>
<style scoped>
.card {
  background: var(--surface-card);
  padding: 0rem;
  border-radius: 10px;
  margin-bottom: 0rem;
}
</style>
